#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <sys/timeb.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <strings.h>
#include <math.h>

#include "config_unix.h"
#include "config_win32.h"
#include "debug.h"

#include "util.h"
#include "config.h"

int main(int argc, char **argv) {
        struct hostent *sndrptr ;
        struct sockaddr_in sndr_addr ;
        int sockfd ;
        char data_buf[PKT_SIZE];
        char *addr;
        short port;
        int tcpbuf_size = 200000;

        int nr = 0;
        int i;

        if (argc < 3) {
                fprintf(stderr, "usage: %s address port\n", argv[0]);
                exit(1);
        } else {
                addr = argv[1];
                port = atoi(argv[2]);
        }

        printf("started ");
        for (i = 0; i < argc; ++i)
                printf("%s ", argv[i]);
        printf("\n");

        init_time();

        if ((sndrptr = gethostbyname(addr)) == NULL) {
		perror ("gethostbyname");
                exit(1);
        }

        bcopy(sndrptr->h_addr, (char *)&sndr_addr.sin_addr, sndrptr->h_length);
        sndr_addr.sin_family = AF_INET ;
        sndr_addr.sin_port = htons(port) ;
	
        if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
                perror ("socket");
   		exit(1);
        }

        setsockopt(sockfd, SOL_SOCKET, SO_RCVBUF, (void *) &tcpbuf_size, sizeof(int));
        setsockopt(sockfd, SOL_SOCKET, SO_SNDBUF, (void *) &tcpbuf_size, sizeof(int));

        /*
        getsockopt(sockfd, SOL_SOCKET, SO_SNDBUF, (void *) &tcpbuf_size, &i);
        printf("bufsize %i,\n",tcpbuf_size);
        */

        if(connect(sockfd,(struct sockaddr *)&sndr_addr,sizeof(sndr_addr))<0){
                perror("connect error");
                close(sockfd);
                exit(1);
        }

        while (nr < MAX_TOTAL_PACKETS) {
                if (write(sockfd, data_buf, PKT_SIZE) <= 0) {
                        perror("tcp: write error");
                        break;
                }
                ++nr;
                debug_msg("\t\t\t%f : %i TCP-packets sent\n", (double) get_time() / MICROSEC, nr);
        }
        close (sockfd);
        if (nr == MAX_TOTAL_PACKETS)
                fprintf(stderr, "maximum number of packets (%i) reached\n", MAX_TOTAL_PACKETS);
        printf("tcpsender finished\n");
        return 0;
}
